# 4.1.3

Release date: `2019-05-28`

Changes in command line arguments:

- Deleted `max-sync-step`.
- Renamed `clean_folder` to `clean-folder`.

## Core

- [NXDRIVE-1074](https://jira.nuxeo.com/browse/NXDRIVE-1074): Remove the Next engine source tree
- [NXDRIVE-1148](https://jira.nuxeo.com/browse/NXDRIVE-1148): Better handle no space left on the device
- [NXDRIVE-1251](https://jira.nuxeo.com/browse/NXDRIVE-1251): Use the token everywhere
- [NXDRIVE-1277](https://jira.nuxeo.com/browse/NXDRIVE-1277): Review objects state export
- [NXDRIVE-1353](https://jira.nuxeo.com/browse/NXDRIVE-1353): When "invalid credentials" occurs, display a direct link to log in in the account settings
- [NXDRIVE-1616](https://jira.nuxeo.com/browse/NXDRIVE-1616): Prevent double lock when DirectEdit'ing a document
- [NXDRIVE-1617](https://jira.nuxeo.com/browse/NXDRIVE-1617): Accept events when the application is not frozen
- [NXDRIVE-1618](https://jira.nuxeo.com/browse/NXDRIVE-1618): Remove inexistant engines from the Manager engines list
- [NXDRIVE-1624](https://jira.nuxeo.com/browse/NXDRIVE-1624): Ensure the lock file integrity is correct
- [NXDRIVE-1631](https://jira.nuxeo.com/browse/NXDRIVE-1631): [Windows] Handle files with the same name but different unicode norms
- [NXDRIVE-1633](https://jira.nuxeo.com/browse/NXDRIVE-1633): Fix supported partition check
- [NXDRIVE-1634](https://jira.nuxeo.com/browse/NXDRIVE-1634): Handle pair state moved-created as a conflict
- [NXDRIVE-1636](https://jira.nuxeo.com/browse/NXDRIVE-1636): Reduce ScrollDescendants calls for each folder
- [NXDRIVE-1637](https://jira.nuxeo.com/browse/NXDRIVE-1637): [macOS] Skip unsaved documents in Photoshop and Illustrator
- [NXDRIVE-1639](https://jira.nuxeo.com/browse/NXDRIVE-1639): Do not allow DirectEdit on older versions of document
- [NXDRIVE-1641](https://jira.nuxeo.com/browse/NXDRIVE-1641): Fix `bind-server` CLI without the `--password` argument
- [NXDRIVE-1644](https://jira.nuxeo.com/browse/NXDRIVE-1644): Fix `LocalWatcher.rootMoved()` signal emitter
- [NXDRIVE-1645](https://jira.nuxeo.com/browse/NXDRIVE-1645): Fix `bind-server` CLI with bad `--password` value
- [NXDRIVE-1647](https://jira.nuxeo.com/browse/NXDRIVE-1647): Check HTTPS when starting an engine
- [NXDRIVE-1648](https://jira.nuxeo.com/browse/NXDRIVE-1648): Removed whitespace characters from URLs
- [NXDRIVE-1649](https://jira.nuxeo.com/browse/NXDRIVE-1649): Review connection errors handling and logging
- [NXDRIVE-1650](https://jira.nuxeo.com/browse/NXDRIVE-1650): Lower logging of invalid SSL certificate in use
- [NXDRIVE-1651](https://jira.nuxeo.com/browse/NXDRIVE-1651): Expand environment variables in paths given to CLI arguments
- [NXDRIVE-1655](https://jira.nuxeo.com/browse/NXDRIVE-1655): Initialize Remote upon connection
- [NXDRIVE-1657](https://jira.nuxeo.com/browse/NXDRIVE-1657): Do not block the application on DirectEdit
- [NXDRIVE-1661](https://jira.nuxeo.com/browse/NXDRIVE-1661): Version compatibility function doesn't return the right result
- [NXDRIVE-1662](https://jira.nuxeo.com/browse/NXDRIVE-1662): [macOS] Handle `NSRangeException` while fetching opened documents in Adobe
- [NXDRIVE-1663](https://jira.nuxeo.com/browse/NXDRIVE-1663): [Windows] Lower logging level of `WindowsIntegration._create_shortcut()`
- [NXDRIVE-1664](https://jira.nuxeo.com/browse/NXDRIVE-1664): Add OS and Python versions to Sentry events
- [NXDRIVE-1665](https://jira.nuxeo.com/browse/NXDRIVE-1665): Ensure coherent response of ScrollDescendants
- [NXDRIVE-1666](https://jira.nuxeo.com/browse/NXDRIVE-1666): Handle lock conflicts in DirectEdit
- [NXDRIVE-1667](https://jira.nuxeo.com/browse/NXDRIVE-1667): Filter out any error in `get_opened_files()`
- [NXDRIVE-1668](https://jira.nuxeo.com/browse/NXDRIVE-1668): Handle `TrashPermissionError` when moving a file to the trash
- [NXDRIVE-1672](https://jira.nuxeo.com/browse/NXDRIVE-1672): Ensure `Application.update_status()` is passed an Engine
- [NXDRIVE-1674](https://jira.nuxeo.com/browse/NXDRIVE-1674): Lower logging level of `get_default_nuxeo_drive_folder()`
- [NXDRIVE-1677](https://jira.nuxeo.com/browse/NXDRIVE-1677): [Windows] Copy-paste and rename a local file while Drive is running does not work
- [NXDRIVE-1675](https://jira.nuxeo.com/browse/NXDRIVE-1675): Catch `MemoryError` in `FileInfo.get_digest()`
- [NXDRIVE-1676](https://jira.nuxeo.com/browse/NXDRIVE-1676): Copy/overwrite db backup files instead of dumping/reading them
- [NXDRIVE-1682](https://jira.nuxeo.com/browse/NXDRIVE-1682): Make the updater more robust against inappropriate server response

## GUI

- [NXDRIVE-1575](https://jira.nuxeo.com/browse/NXDRIVE-1575): Add a link to the update site on the fatal error window
- [NXDRIVE-1580](https://jira.nuxeo.com/browse/NXDRIVE-1580): When account is added, after filters are chosen, close the settings window
- [NXDRIVE-1605](https://jira.nuxeo.com/browse/NXDRIVE-1605): Display the server name next to the username in the accounts list
- [NXDRIVE-1643](https://jira.nuxeo.com/browse/NXDRIVE-1643): [Windows] Switch and radio button text is truncated with ellipsis with zoom at 175%

## Packaging / Build

- [NXDRIVE-1606](https://jira.nuxeo.com/browse/NXDRIVE-1606): Publish ZIP'ed version of packages
- [NXDRIVE-1632](https://jira.nuxeo.com/browse/NXDRIVE-1632): [Windows] Prepare Nuitka switch
- [NXDRIVE-1646](https://jira.nuxeo.com/browse/NXDRIVE-1646): Fix SSH links in Jenkinsfiles

## Tests

- [NXDRIVE-1583](https://jira.nuxeo.com/browse/NXDRIVE-1583): [Windows] Add first integration tests: CLI arguments
- [NXDRIVE-1623](https://jira.nuxeo.com/browse/NXDRIVE-1623): [Windows] Add CLI sub-commands tests: clean-folder, console, bind-server and unbind-server
- [NXDRIVE-1678](https://jira.nuxeo.com/browse/NXDRIVE-1678): Re-run failed tests

## Doc

- [NXDRIVE-1635](https://jira.nuxeo.com/browse/NXDRIVE-1635): Add "Version Added" in documentation parameters
- [NXDRIVE-1654](https://jira.nuxeo.com/browse/NXDRIVE-1654): Improve the support documentation

## Minor Changes

- Packaging: Added `pywinauto` 0.6.6
- Packaging: Updated `faker` from 1.0.4 to 1.0.7
- Packaging: Updated `markdown` from 3.0.1 to 3.1
- Packaging: Updated `mypy` from 0.670 to 0.701
- Packaging: Updated `pre-commit` from 1.14.4 to 1.16.1
- Packaging: Updated `psutil` from 1.14.4 to 1.16.0
- Packaging: Updated `pyaml` from 5.6.1 to 5.6.2
- Packaging: Updated `pycryptodomex` from 3.7.3 to 3.8.1
- Packaging: Updated `pytest` 4.3.1 to 4.5.0
- Packaging: Updated `pytest-cov` from 2.6.1 to 2.7.1
- Packaging: Updated `pytest-xdist` from 1.26.1 to 1.28.0
- Testing: Separate tests execution and launch synchronization tests file by file to prevent server overload

## Technical Changes

- Added `Application.add_qml_import_path()`
- Added `DocPair.export()`
- Added `Engine.authChanged` signal
- Added `Engine.export()`
- Added `Engine.fileAlreadyExists` signal
- Added `EngineModel.authChanged` signal
- Renamed `FileInfo.has_children()` to `folderish()`
- Renamed `FsFileInfo.has_children()` to `folderish()`
- Renamed `FsClient.fs_client` to `remote`
- Renamed `FolderTreeview.itemChanged()` to `resolve_item()`
- Renamed `FolderTreeview.itemExpanded()` to `expand_item()`
- Renamed `FolderTreeview.setLoad()` to `set_loading_cursor()`
- Removed `FolderTreeview.load_children_thread()`
- Removed `FolderTreeview.overlay`
- Removed `FolderTreeview.showHideLoadingOverlay` signal
- Removed `LocalClient.CASE_RENAME_PREFIX`
- Added `LocalWatcher.fileAlreadyExists` signal
- Changed `home` argument of `Manager.__init__()` from keyword argument to positional argument, now mandatory.
- Added `Notification.export()`
- Added `NuxeoDocumentInfo.is_version`
- Added `Options.freezer`
- Renamed `QMLDriveApi.default_nuxeo_drive_folder()` to `default_local_folder()`
- Removed `include_versions` keyword argument from `Remote.exists()`
- Removed `include_versions` keyword argument from `Remote.get_info()`
- Added `Worker.export()`
- Added constants.py::`BATCH_SIZE`
- Added constants.py::`CONNECTION_ERROR`
- Added constants.py::`NO_SPACE_ERRORS`
- Removed data/icons/loader.gif
- Removed data/icons/overlay/win32/
- Deleted engine/next
- Added exceptions.py::`DocumentAlreadyLocked`
- Added exceptions.py::`ScrollDescendantsError`
- Moved gui/api.py::`get_date_from_sqlite()` to utils.py
- Moved gui/api.py::`get_timestamp_from_date()` to utils.py
- Added gui/folders_treeview.py::`ContentLoader`
- Renamed gui/folders_treeview.py::`FilteredFsClient` to `FsClient`
- Removed gui/folders_treeview.py::`Overlay`
- Added utils.py::`normalize_and_expand_path()`
- Changed utils.py::`get_current_os()` to return `tuple(str, str)` rather than `str`
- Renamed utils.py::`get_default_nuxeo_drive_folder()` to `get_default_local_folder()`
