# 4.2.0

Release date: `2019-09-26`

## Core

- [NXDRIVE-445](https://jira.nuxeo.com/browse/NXDRIVE-445): [GNU/Linux] Add support for the custom URL protocol
- [NXDRIVE-1473](https://jira.nuxeo.com/browse/NXDRIVE-1473): Add GNU/Linux support to the auto-updater
- [NXDRIVE-1491](https://jira.nuxeo.com/browse/NXDRIVE-1491): Do not use bare exceptions
- [NXDRIVE-1708](https://jira.nuxeo.com/browse/NXDRIVE-1708): Handle Unauthorized access when Direct Edit'ing a doc with an outdated token
- [NXDRIVE-1783](https://jira.nuxeo.com/browse/NXDRIVE-1783): Handle account addition with already used local folder
- [NXDRIVE-1747](https://jira.nuxeo.com/browse/NXDRIVE-1747): Fix the SSL support on GNU/Linux
- [NXDRIVE-1784](https://jira.nuxeo.com/browse/NXDRIVE-1784): Remove unused objects and add CI/QA checks
- [NXDRIVE-1787](https://jira.nuxeo.com/browse/NXDRIVE-1787): Ensure `Engine.newError` is passed an Engine
- [NXDRIVE-1788](https://jira.nuxeo.com/browse/NXDRIVE-1788): Ensure `Application.action_progressing()` is passing an Action
- [NXDRIVE-1803](https://jira.nuxeo.com/browse/NXDRIVE-1803): Add a new update channel: `Centralized`
- [NXDRIVE-1807](https://jira.nuxeo.com/browse/NXDRIVE-1807): Improve startup SSL check wording
- [NXDRIVE-1812](https://jira.nuxeo.com/browse/NXDRIVE-1812): Add a new option to quit the application after the sync is over
- [NXDRIVE-1813](https://jira.nuxeo.com/browse/NXDRIVE-1813): Ignore engines that cannot be initalized
- [NXDRIVE-1814](https://jira.nuxeo.com/browse/NXDRIVE-1814): Gracefully exit the application on CTRL+C
- [NXDRIVE-1816](https://jira.nuxeo.com/browse/NXDRIVE-1816): Remove access to private methods
- [NXDRIVE-1824](https://jira.nuxeo.com/browse/NXDRIVE-1824): Resuming a download fails if the temporary file was deleted
- [NXDRIVE-1830](https://jira.nuxeo.com/browse/NXDRIVE-1830): Rotating logs check-up
- [NXDRIVE-1832](https://jira.nuxeo.com/browse/NXDRIVE-1832): Fix a regression that prevents deep structure sync (introduced in 4.1.3 with [NXDRIVE-1636](https://jira.nuxeo.com/browse/NXDRIVE-1636))
- [NXDRIVE-1842](https://jira.nuxeo.com/browse/NXDRIVE-1842): Skip update when no file is provided for a given version on a given OS
- [NXDRIVE-1845](https://jira.nuxeo.com/browse/NXDRIVE-1845): Prevent a crash if the local folder does not exist anymore
- [NXDRIVE-1846](https://jira.nuxeo.com/browse/NXDRIVE-1846): Do not log the whole exception when checking for HTTS support on a development environment

## GUI

- [NXDRIVE-1749](https://jira.nuxeo.com/browse/NXDRIVE-1749): [GNU/Linux] Systray menu is not at the good location
- [NXDRIVE-1782](https://jira.nuxeo.com/browse/NXDRIVE-1782): Provide information on transfer speed
- [NXDRIVE-1802](https://jira.nuxeo.com/browse/NXDRIVE-1802): [macOS] Automatically use light icons if the dark mode is in use
- [NXDRIVE-1806](https://jira.nuxeo.com/browse/NXDRIVE-1806): Fix transfered files list refreshing in the systray
- [NXDRIVE-1819](https://jira.nuxeo.com/browse/NXDRIVE-1819): Use arrows to indicate transfer type in speed metrics
- [NXDRIVE-1821](https://jira.nuxeo.com/browse/NXDRIVE-1821): Fix update from the systray after failing update
- [NXDRIVE-1823](https://jira.nuxeo.com/browse/NXDRIVE-1823): Update the sync count after resuming transfers at startup
- [NXDRIVE-1825](https://jira.nuxeo.com/browse/NXDRIVE-1825): Display the transfer speed at 1s interval (or more)
- [NXDRIVE-1828](https://jira.nuxeo.com/browse/NXDRIVE-1828): [Windows] Report generation result line hides a line in the GUI
- [NXDRIVE-1840](https://jira.nuxeo.com/browse/NXDRIVE-1840): Fix the progress bar animation duration
- [NXDRIVE-1844](https://jira.nuxeo.com/browse/NXDRIVE-1844): Use light icons on Manjaro Linux

## Packaging / Build

- [NXDRIVE-1748](https://jira.nuxeo.com/browse/NXDRIVE-1748): Deploy GNU/Linux artifacts
- [NXDRIVE-1755](https://jira.nuxeo.com/browse/NXDRIVE-1755): [GNU/Linux] Check AppImage requirements
- [NXDRIVE-1757](https://jira.nuxeo.com/browse/NXDRIVE-1757): Set module hashes in requirements files
- [NXDRIVE-1797](https://jira.nuxeo.com/browse/NXDRIVE-1797): [Windows] Upgrade from Inno Setup 5.5.9 to 6.0.2
- [NXDRIVE-1798](https://jira.nuxeo.com/browse/NXDRIVE-1798): [Windows] Use the Inno Setup modern wizard style

## Tests

- [NXDRIVE-1706](https://jira.nuxeo.com/browse/NXDRIVE-1706): Expand `utils.py` tests coverage
- [NXDRIVE-1741](https://jira.nuxeo.com/browse/NXDRIVE-1741): [Windows] Add CLI sub-commands tests: `bind-root` and `unbind-root`
- [NXDRIVE-1815](https://jira.nuxeo.com/browse/NXDRIVE-1815): [Windows] Add CLI sub-commands tests: context menu entries
- [NXDRIVE-1818](https://jira.nuxeo.com/browse/NXDRIVE-1818): Reactivate the volume test
- [NXDRIVE-1850](https://jira.nuxeo.com/browse/NXDRIVE-1850): Update artifact URL for functional tests

## Doc

- [NXDRIVE-1761](https://jira.nuxeo.com/browse/NXDRIVE-1761): Document the team workflow

## Minor Changes

- Packaging: Added `altgraph` 0.16.1
- Packaging: Added `certifi` 2019.6.16
- Packaging: Added `cffi` 1.12.3
- Packaging: Added `chardet` 3.0.4
- Packaging: Added `dukpy` 0.2.2
- Packaging: Added `future` 0.17.1
- Packaging: Added `idna` 2.8
- Packaging: Added `macholib` 0.11
- Packaging: Added `pefile` 2019.4.18
- Packaging: Added `pycparser` 2.19
- Packaging: Added `pyobjc-core` 4.2.2
- Packaging: Added `pyobjc-framework-FSEvents` 4.2.2
- Packaging: Added `pyobjc-framework-SystemConfiguration` 4.2.2
- Packaging: Added `pyyaml` 5.1.2
- Packaging: Added `pywin32` 224
- Packaging: Added `six` 1.12.0
- Packaging: Added `tld` 0.9.3
- Packaging: Updated `pyqt5` from 5.11.2 to 5.13.0 on GNU/Linux and Windows
- Packaging: Removed `appdirs`
- Packaging: Removed `pypiwin32`
- Packaging: Updated `nuxeo` to 2.2.2
- Packaging: Updated `pycryptodomex` from 3.8.2 to 3.9.0
- Packaging: Updated `sentry-sdk` from 0.10.2 to 0.11.2

## Technical Changes

- Added `AbstractOSIntegration.cleanup()`
- Added `AbstractOSIntegration.init()`
- Removed `AbstractOSIntegration.zoom_factor`
- Removed `Action.get_last_file_action()`
- Removed `Action.lastFileActions`
- Added `Application.open_authentication_dialog()`
- Removed `BaseUpdater.force_downgrade()`
- Removed `BaseUpdater.force_status()`
- Added `ConfigurationDAO.conn`
- Added `ConfigurationDAO.lock`
- Removed `ConfigurationDAO.get_db()`. Use `db` attribute instead.
- Added `DarwinIntegration.cleanup()`
- Added `DarwinIntegration.dark_mode_in_use()`
- Added `DarwinIntegration.current_them()`
- Added `DarwinIntegration.init()`
- Removed `Engine.get_threads()`
- Added `ExtensionListener.start_listening()`
- Added `FileAction.chunk_size`
- Added `FileAction.chunk_transfer_end_time_ns`
- Added `FileAction.chunk_transfer_start_time_ns`
- Added `FileAction.last_chunk_transfer_speed`
- Added `FileAction.transferred_chunks`
- Removed `FileAction.end_time`
- Removed `FileAction.start_time`
- Removed `FileAction.transfer_duration`
- Added `LinuxIntegration.register_protocol_handlers()`
- Removed `Manager.get_default_server_type()`. Use `DEFAULT_SERVER_TYPE` constant instead.
- Added `Manager.get_server_login_type()`
- Added `NotificationDelegator.manager`
- Removed `Notification.get_replacements()`
- Changed default value of `Options.channel` from `release` to `centralized`
- Added `Options.client_version`
- Added `Options.sync_and_quit`
- Added `PidLockFile.pid_filepath`
- Removed `PidLockFile.folder`
- Removed `process_name` keyword argument from `PidLockFile.check_running()`
- Added `QMLDriveApi.callback_params`
- Removed `QMLDriveApi.set_language()`
- Removed `direction` keyword argument from `QMLDriveApi.get_last_files()`
- Removed `duration` keyword argument from `QMLDriveApi.get_last_files()`
- Removed `QMLDriveApi.get_actions()`
- Removed `QMLDriveApi.get_conflicts_count()`
- Removed `QMLDriveApi.get_errors_count()`
- Removed `QMLDriveApi.get_threads()`
- Removed `QMLDriveApi.get_update_progress()`
- Added `Remote.base_folder_ref`
- Added `Remote.check_ref()`
- Added `Remote.transfer_end_callback()`
- Added `Remote.transfer_start_callback()`
- Changed return type of `Remote.upload_chunks()` from `Tuple[FileBlob, int]` to `FileBlob`
- Removed `Remote.kwargs`
- Removed `duration` argument from `Remote.link_blob_to_doc()`
- Added `RemoteWatcher.scan_remote()`
- Added `TimedCompressedRotatingFileHandler.checkup()`
- Added `TimedCompressedRotatingFileHandler.compress()`
- Added `TimedCompressedRotatingFileHandler.compress_all()`
- Added `TimedCompressedRotatingFileHandler.find_rotated_files()`
- Added `TimedCompressedRotatingFileHandler.remove_old_files()`
- Removed `TimedCompressedRotatingFileHandler.find_last_rotated_file()`
- Removed `Tracker.connect_engine()`
- Removed `TransferStatus.CANCELLED`
- Added `Translator.current_language`
- Added `Translator.get_translation()`
- Added `Translator.langs`
- Added `Translator.set_language()`
- Added `Translator.singleton`
- Removed `Translator.translations()`
- Added `WindowsIntegration.cleanup()`
- Added `WindowsIntegration.init()`
- Removed `WindowsIntegration.zoom_factor`
- Added constants.py:`DEFAULT_CHANNEL`
- Added constants.py:`DEFAULT_SERVER_TYPE`
- Added constants.py:`NXDRIVE_SCHEME`
- Added exceptions.py::`EngineInitError`
- Added options.py::`validate_client_version()`
- Added poll_worker.py::`SyncAndQuitWorker`
- Added utils.py::`DEFAULTS_CERT_DETAILS`
- Added `cls` keyword argument to utils.py::`normalized_path()`
- Removed utils.py::`WIN32_PATCHED_MIME_TYPES`
